proc (0)= swmisspc(beta0,dta);
local itertime, nobs, hgrd, ncol, c, a, chistat, n1, n2, n3;

"White's Misspecification Tests:";
hgrd = swgrad(beta0,dta);	ncol=cols(hgrd);	nobs=rows(dta);
n1=_n1+1;	n2=_n1+_n2+1;	n3=ncol-1;
"Joint Test for Misspecification is Chi-sq(5) under the null.";
c = hgrd[1:nobs-1,1 n1 n2 n3 ncol].*hgrd[2:nobs,1 n1 n2 n3 ncol];
a = hgrd[2:nobs,.]~c;
a = invpd(a'*a);
a = a[ncol+1:ncol+5,ncol+1:ncol+5];
chistat = sumc(c);
chistat = chistat'*a*chistat;
chistat;;		",  Signif. = ";; cdfchic(chistat,5);

"AR(1) Test for Regime 1 is Chi-Sq(1) under the null.";
c = hgrd[1:nobs-1,1].*hgrd[2:nobs,1];
a = hgrd[2:nobs,.]~c;
a = invpd(a'*a);
a = a[ncol+1,ncol+1];
chistat = sumc(c);
chistat = chistat'*a*chistat;
chistat;;		",  Signif. = ";; cdfchic(chistat,1);

"AR(1) Test for Regime 2 is Chi-Sq(1) under the null.";
c = hgrd[1:nobs-1,n1].*hgrd[2:nobs,n1];
a = hgrd[2:nobs,.]~c;
a = invpd(a'*a);
a = a[ncol+1,ncol+1];
chistat = sumc(c);
chistat = chistat'*a*chistat;
chistat;;		",  Signif. = ";; cdfchic(chistat,1);

"ARCH(1) Test for Regime 1 is Chi-Sq(1) under the null.";
c = hgrd[1:nobs-1,n3].*hgrd[2:nobs,n3];
a = hgrd[2:nobs,.]~c;
a = invpd(a'*a);
a = a[ncol+1,ncol+1];
chistat = sumc(c);
chistat = chistat'*a*chistat;
chistat;;		",  Signif. = ";; cdfchic(chistat,1);

"ARCH(1) Test for Regime 2 is Chi-Sq(1) under the null.";
c = hgrd[1:nobs-1,ncol].*hgrd[2:nobs,ncol];
a = hgrd[2:nobs,.]~c;
a = invpd(a'*a);
a = a[ncol+1,ncol+1];
chistat = sumc(c);
chistat = chistat'*a*chistat;
chistat;;		",  Signif. = ";; cdfchic(chistat,1);

"Test for Omitted Markov Effects is Chi-Sq(1) under the null.";
c = hgrd[1:nobs-1,n2].*hgrd[2:nobs,n2];
a = hgrd[2:nobs,.]~c;
a = invpd(a'*a);
a = a[ncol+1,ncol+1];
chistat = sumc(c);
chistat = chistat'*a*chistat;
chistat;;		",  Signif. = ";; cdfchic(chistat,1);


endp;
